/* Jentchina - CnlJentchina
 * STRASSER Michel - 20040329		init
 * */



#ifndef __JNA_CNL_JENTCHINA_H__
#define __JNA_CNL_JENTCHINA_H__

#include <glib.h>
#include <glib-object.h>
#include <lsmlib.h>
#include "JnaCnlIter.h"

#define	JNA_TYPE_CNL_JENTCHINA			(JnaCnlJentchina_getType ())
#define JNA_CNL_JENTCHINA(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_CNL_JENTCHINA, JnaCnlJentchina))
#define JNA_CNL_JENTCHINA_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_CNL_JENTCHINA, JnaCnlJentchinaClass))
#define JNA_IS_CNL_JENTCHINA(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_CNL_JENTCHINA))
#define JNA_IS_CNL_JENTCHINA_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_CNL_JENTCHINA))
#define JNA_CNL_JENTCHINA_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_CNL_JENTCHINA_TYPE_NAME(object)	  (g_type_name (JNA_CNL_JENTCHINA_TYPE (object)))

typedef struct _JnaCnlJentchina	JnaCnlJentchina;
typedef struct _JnaCnlJentchinaClass	JnaCnlJentchinaClass;

typedef enum {
	JnaFilterType_IMPORT,
	JnaFilterType_EXPORT,
	JnaFilterType_NUM
} JnaFilterType;

typedef enum {
	JnaCnlStatus_OK,
	JnaCnlStatus_INVALID_OBJ,
	JnaCnlStatus_INVALID_ITER,
	JnaCnlStatus_INVALID_SESSION_KEY,
	JnaCnlStatus_APPLY_FILTER_ERROR,
	JnaCnlStatus_SYSTEM_ERROR, /* may be network error */
	JnaCnlStatus_NUM
} JnaCnlStatus;

struct _JnaCnlJentchina
{
	GObject 		parent_instance;
	GObject*		filtersTree[JnaFilterType_NUM];
	GObject*		grabber;
	GObject*		cacheAndBank;
	char* 			appName;
};

struct _JnaCnlJentchinaClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaCnlJentchina_getType		(void);


GObject* 	
JnaCnlJentchina_new		(char* appName);

JnaCnlStatus
JnaCnlJentchina_getRendezVous	(JnaCnlJentchina* self,
				 JnaCnlIter iter,
				 char* user,
				 char* password,
				 LsmTree* doc,
				 GList** out_interfacesList, /* newly allocated */
				 int* out_vortexLifeTime,
				 char** out_sessionKey);     /* newly allocated */
				 
JnaCnlStatus
JnaCnlJentchina_applyFilter	(JnaCnlJentchina* self,
				 char* sessionKey,
				 char* interfaces,
				 LsmTree** out_filteredDoc);	/* newly allocated */
				 

void
JnaCnlJentchina_print		(JnaCnlJentchina* self);

G_END_DECLS

#endif /* __JNA_CNL_JENTCHINA_H__ */
