/* Jentchina - CnlServerTreeModel
 * STRASSER Michel - 20040329		init
 * */

#ifndef __JNA_CNL_SERVER_TREE_MODEL_H__
#define __JNA_CNL_SERVER_TREE_MODEL_H__

#include <glib.h>
#include <glib-object.h>
#include "../API/pack_API.h"


#define	JNA_TYPE_CNL_SERVER_TREE_MODEL			(JnaCnlServerTreeModel_getType ())
#define JNA_CNL_SERVER_TREE_MODEL(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_CNL_SERVER_TREE_MODEL, JnaCnlServerTreeModel))
#define JNA_CNL_SERVER_TREE_MODEL_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_CNL_SERVER_TREE_MODEL, JnaCnlServerTreeModelClass))
#define JNA_IS_CNL_SERVER_TREE_MODEL(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_CNL_SERVER_TREE_MODEL))
#define JNA_IS_CNL_SERVER_TREE_MODEL_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_CNL_SERVER_TREE_MODEL))
#define JNA_CNL_SERVER_TREE_MODEL_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_CNL_SERVER_TREE_MODEL_TYPE_NAME(object)	  (g_type_name (JNA_CNL_SERVER_TREE_MODEL_TYPE (object)))

typedef struct _JnaCnlServerTreeModel	JnaCnlServerTreeModel;
typedef struct _JnaCnlServerTreeModelClass	JnaCnlServerTreeModelClass;

struct _JnaCnlServerTreeModel
{
	JentchinaTreeModel	parent_instance;
	GObject*		tree;	/* JnaCnlFiltersTree */
};

struct _JnaCnlServerTreeModelClass
{
	JentchinaTreeModelClass parent_class;
};

G_BEGIN_DECLS

GType		
JnaCnlServerTreeModel_getType		(void);


GObject* 	
JnaCnlServerTreeModel_new			(GObject* tree);	/* JnaCnlFiltersTree */


G_END_DECLS

#endif /* __JNA_CNL_SERVER_TREE_MODEL_H__ */
