/* Jentchina - CnlStream
 * STRASSER Michel - 20040206		init
 * STRASSER Michel - 20040317		class renaming Jna::Stream -> Jna::Cnl::Stream
 * */



#ifndef __JNA_CNL_STREAM_H__
#define __JNA_CNL_STREAM_H__

#include <glib.h>
#include <glib-object.h>


#define	JNA_TYPE_CNL_STREAM			(JnaCnlStream_getType ())
#define JNA_CNL_STREAM(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_CNL_STREAM, JnaCnlStream))
#define JNA_CNL_STREAM_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_CNL_STREAM, JnaCnlStreamClass))
#define JNA_IS_CNL_STREAM(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_CNL_STREAM))
#define JNA_IS_CNL_STREAM_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_CNL_STREAM))
#define JNA_CNL_STREAM_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_CNL_STREAM_TYPE_NAME(object)	  (g_type_name (JNA_CNL_STREAM_TYPE (object)))

typedef struct _JnaCnlStream	JnaCnlStream;
typedef struct _JnaCnlStreamClass	JnaCnlStreamClass;

struct _JnaCnlStream
{
	GObject 		parent_instance;
	unsigned char*		seq;
	unsigned int		length;
};

struct _JnaCnlStreamClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaCnlStream_getType		(void);


/* seq is copied in the structure, so you may free seq after having
 * called this constructor
 * */
GObject* 	
JnaCnlStream_new		(unsigned char* seq,	
				 unsigned int length);

gboolean /* returns FALSE if there was an error */
JnaCnlStream_writeIntoFile	(JnaCnlStream*	self,
				 char* file);


G_END_DECLS

#endif /* __JNA_CNL_STREAM_H__ */
