/* Jentchina - ComCorbamunication sub system
 * STRASSER Michel - 20040201		init
 * */

#ifndef __JNA_COM_CORBA_H__
#define __JNA_COM_CORBA_H__

#include <glib.h>
#include <glib-object.h>
#include "../JnaCom.h"
#include "Lioubliou.h"
#include <orbit/orbit.h>
#include "examples-toolkit.h"

#define	JNA_TYPE_COM_CORBA			(JnaComCorba_getType ())
#define JNA_COM_CORBA(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_COM_CORBA, JnaComCorba))
#define JNA_COM_CORBA_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_COM_CORBA, JnaComCorbaClass))
#define JNA_IS_COM_CORBA(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_COM_CORBA))
#define JNA_IS_COM_CORBA_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_COM_CORBA))
#define JNA_COM_CORBA_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_COM_CORBA_TYPE_NAME(object)	  (g_type_name (JNA_COM_CORBA_TYPE (object)))

typedef struct _JnaComCorba		JnaComCorba;
typedef struct _JnaComCorbaClass	JnaComCorbaClass;

struct _JnaComCorba
{
	JnaCom 			parent_instance;
	Lioubliou_Server 	service;
};

struct _JnaComCorbaClass
{
	JnaComClass 		parent_class;
	CORBA_ORB  		orb; /* orb */
};

G_BEGIN_DECLS

GType		
JnaComCorba_getType			(void);

GObject* 	
JnaComCorba_new				(char* option);

G_END_DECLS

#endif /* __JNA_COM_CORBA_H__ */
