/* Jentchina - Communication sub system
 * STRASSER Michel - 20040131		init
 * */



#ifndef __JNA_COM_RENDEZ_VOUS_H__
#define __JNA_COM_RENDEZ_VOUS_H__

#include <glib.h>
#include <glib-object.h>


#define	JNA_TYPE_COM_RENDEZ_VOUS			(JnaComRendezVous_getType ())
#define JNA_COM_RENDEZ_VOUS(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_COM_RENDEZ_VOUS, JnaComRendezVous))
#define JNA_COM_RENDEZ_VOUS_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_COM_RENDEZ_VOUS, JnaComRendezVousClass))
#define JNA_IS_COM_RENDEZ_VOUS(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_COM_RENDEZ_VOUS))
#define JNA_IS_COM_RENDEZ_VOUS_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_COM_RENDEZ_VOUS))
#define JNA_COM_RENDEZ_VOUS_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_COM_RENDEZ_VOUS_TYPE_NAME(object)	  (g_type_name (JNA_COM_RENDEZ_VOUS_TYPE (object)))

typedef struct _JnaComRendezVous	JnaComRendezVous;
typedef struct _JnaComRendezVousClass	JnaComRendezVousClass;

struct _JnaComRendezVous
{
	GObject 	parent_instance;
	char* sessionKey;
	GList*		interfacesList;
	int		vortexLifeTime;
	int		creationTime;
};

struct _JnaComRendezVousClass
{
	GObjectClass parent_class;
};

G_BEGIN_DECLS

GType		
JnaComRendezVous_getType		(void);

// interfacesList would be freed in the JnaComRendezVous class destructor
GObject* 	
JnaComRendezVous_new			(char* sessionKey, 
					 GList* interfacesList,	
					 int vortexLifeTime);

gboolean
JnaComRendezVous_isVortexClosed		(JnaComRendezVous* self);

G_END_DECLS

#endif /* __JNA_COM_RENDEZ_VOUS_H__ */
