/* Jentchina - XAuthorInfoReadersListReader - Xml reader helping object
 * STRASSER Michel - 20040301		init
 * */
#ifndef __JNA_X_AUTHOR_INFO_READER_H__
#define __JNA_X_AUTHOR_INFO_READER_H__

#include <glib.h>
#include <glib-object.h>

#define	JNA_TYPE_X_AUTHOR_INFO_READER			(JnaXAuthorInfoReader_getType ())
#define JNA_X_AUTHOR_INFO_READER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_X_AUTHOR_INFO_READER, JnaXAuthorInfoReader))
#define JNA_X_AUTHOR_INFO_READER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_X_AUTHOR_INFO_READER, JnaXAuthorInfoReaderClass))
#define JNA_IS_X_AUTHOR_INFO_READER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_X_AUTHOR_INFO_READER))
#define JNA_IS_X_AUTHOR_INFO_READER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_X_AUTHOR_INFO_READER))
#define JNA_X_AUTHOR_INFO_READER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_X_AUTHOR_INFO_READER_TYPE_NAME(object)	  (g_type_name (JNA_X_AUTHOR_INFO_READER_TYPE (object)))

typedef struct _JnaXAuthorInfoReader	JnaXAuthorInfoReader;
typedef struct _JnaXAuthorInfoReaderClass	JnaXAuthorInfoReaderClass;

struct _JnaXAuthorInfoReader
{
	GObject 		parent_instance;
	char* 			id;
	char* 			name;
	char* 			email;
};

struct _JnaXAuthorInfoReaderClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaXAuthorInfoReader_getType		(void);


/* you can free xmlFile after calling this constructor */
GObject* 	
JnaXAuthorInfoReader_new			(char* xmlFile);

/* newly allocated */
char*
JnaXAuthorInfoReader_toString		(JnaXAuthorInfoReader* self);

void
JnaXAuthorInfoReader_print		(JnaXAuthorInfoReader* self);


G_END_DECLS

#endif /* __JNA_X_AUTHOR_INFO_READER_H__ */
