/* Jentchina - GrbURL
 * STRASSER Michel - 20040329		init
 * */



#ifndef __JNA_GRB_URL_H__
#define __JNA_GRB_URL_H__

#include <glib.h>
#include <glib-object.h>
#include <lsmlib.h>

#define	JNA_TYPE_GRB_URL			(JnaGrbURL_getType ())
#define JNA_GRB_URL(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_GRB_URL, JnaGrbURL))
#define JNA_GRB_URL_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_GRB_URL, JnaGrbURLClass))
#define JNA_IS_GRB_URL(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_GRB_URL))
#define JNA_IS_GRB_URL_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_GRB_URL))
#define JNA_GRB_URL_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_GRB_URL_TYPE_NAME(object)	  (g_type_name (JNA_GRB_URL_TYPE (object)))

typedef struct _JnaGrbURL	JnaGrbURL;
typedef struct _JnaGrbURLClass	JnaGrbURLClass;

struct _JnaGrbURL
{
	GObject 		parent_instance;
	char*			stream;
	unsigned long long	checkSum;
};

struct _JnaGrbURLClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaGrbURL_getType		(void);


GObject* 	
JnaGrbURL_new			(char* url);

G_END_DECLS

#endif /* __JNA_GRB_URL_H__ */
