/* Jentchina - XFiltersTreeReadersListReader - Xml reader helping object
 * STRASSER Michel - 20040301		init
 * */
#ifndef __JNA_X_FILTERS_TREE_READER_H__
#define __JNA_X_FILTERS_TREE_READER_H__

#include <glib.h>
#include <glib-object.h>

#define	JNA_TYPE_X_FILTERS_TREE_READER			(JnaXFiltersTreeReader_getType ())
#define JNA_X_FILTERS_TREE_READER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_X_FILTERS_TREE_READER, JnaXFiltersTreeReader))
#define JNA_X_FILTERS_TREE_READER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_X_FILTERS_TREE_READER, JnaXFiltersTreeReaderClass))
#define JNA_IS_X_FILTERS_TREE_READER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_X_FILTERS_TREE_READER))
#define JNA_IS_X_FILTERS_TREE_READER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_X_FILTERS_TREE_READER))
#define JNA_X_FILTERS_TREE_READER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_X_FILTERS_TREE_READER_TYPE_NAME(object)	  (g_type_name (JNA_X_FILTERS_TREE_READER_TYPE (object)))

typedef struct _JnaXFiltersTreeReader	JnaXFiltersTreeReader;
typedef struct _JnaXFiltersTreeReaderClass	JnaXFiltersTreeReaderClass;

struct _JnaXFiltersTreeReader
{
	GObject 		parent_instance;
	GNode* 			root;
};

struct _JnaXFiltersTreeReaderClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaXFiltersTreeReader_getType		(void);


/* you can free xmlFile after calling this constructor */
GObject* 	
JnaXFiltersTreeReader_new			(char* xmlFile);

/* newly allocated */
char*
JnaXFiltersTreeReader_toString		(JnaXFiltersTreeReader* self);

void
JnaXFiltersTreeReader_print		(JnaXFiltersTreeReader* self);


G_END_DECLS

#endif /* __JNA_X_FILTERS_TREE_READER_H__ */
