/* Jentchina - XServer - Xml reader helping object
 * STRASSER Michel - 20040301		init
 * */

#ifndef __JNA_X_SERVER_H__
#define __JNA_X_SERVER_H__

#include <glib.h>
#include <glib-object.h>


#define	JNA_TYPE_X_SERVER			(JnaXServer_getType ())
#define JNA_X_SERVER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_X_SERVER, JnaXServer))
#define JNA_X_SERVER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_X_SERVER, JnaXServerClass))
#define JNA_IS_X_SERVER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_X_SERVER))
#define JNA_IS_X_SERVER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_X_SERVER))
#define JNA_X_SERVER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_X_SERVER_TYPE_NAME(object)	  (g_type_name (JNA_X_SERVER_TYPE (object)))

typedef struct _JnaXServer	JnaXServer;
typedef struct _JnaXServerClass	JnaXServerClass;

struct _JnaXServer
{
	GObject 		parent_instance;
	char*			strategy;
	char*			opt;
};

struct _JnaXServerClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaXServer_getType		(void);


/* startegy and opt are copied in the structure, so you may free them after having
 * called this constructor
 * */
GObject* 	
JnaXServer_new			(char* strategy,	
				 char* opt);

/* newly allocated */
char*
JnaXServer_toString		(JnaXServer* self);

void
JnaXServer_print		(JnaXServer* self);


G_END_DECLS

#endif /* __JNA_X_SERVER_H__ */
