/* Jentchina - XServerInfoReadersListReader - Xml reader helping object
 * STRASSER Michel - 20040301		init
 * STRASSER Michel - 20040317		adding domain
 * */
#ifndef __JNA_X_SERVER_INFO_READER_H__
#define __JNA_X_SERVER_INFO_READER_H__

#include <glib.h>
#include <glib-object.h>

#define	JNA_TYPE_X_SERVER_INFO_READER			(JnaXServerInfoReader_getType ())
#define JNA_X_SERVER_INFO_READER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_X_SERVER_INFO_READER, JnaXServerInfoReader))
#define JNA_X_SERVER_INFO_READER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_X_SERVER_INFO_READER, JnaXServerInfoReaderClass))
#define JNA_IS_X_SERVER_INFO_READER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_X_SERVER_INFO_READER))
#define JNA_IS_X_SERVER_INFO_READER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_X_SERVER_INFO_READER))
#define JNA_X_SERVER_INFO_READER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_X_SERVER_INFO_READER_TYPE_NAME(object)	  (g_type_name (JNA_X_SERVER_INFO_READER_TYPE (object)))

typedef struct _JnaXServerInfoReader	JnaXServerInfoReader;
typedef struct _JnaXServerInfoReaderClass	JnaXServerInfoReaderClass;

struct _JnaXServerInfoReader
{
	GObject 		parent_instance;
	char* 			domain;
	char* 			id;
	char* 			name;
};

struct _JnaXServerInfoReaderClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaXServerInfoReader_getType		(void);


/* you can free xmlFile after calling this constructor */
GObject* 	
JnaXServerInfoReader_new			(char* xmlFile);

GObject* 	
JnaXServerInfoReader_newFromStream		(GObject* stream);	/* JnaCnlStream */


/* newly allocated */
char*
JnaXServerInfoReader_toString		(JnaXServerInfoReader* self);

void
JnaXServerInfoReader_print		(JnaXServerInfoReader* self);

void
JnaXServerInfoReader_getInfo		(JnaXServerInfoReader* self,
					 char** out_domain, 	/* NOT newly allocated */
					 char** out_id,		/* NOT newly allocated */
					 char** out_name);	/* NOT newly allocated */



G_END_DECLS

#endif /* __JNA_X_SERVER_INFO_READER_H__ */
