/* Jentchina - XServersListReadersListReader - Xml reader helping object
 * STRASSER Michel - 20040301		init
 * */
#ifndef __JNA_X_SERVERS_LIST_READER_H__
#define __JNA_X_SERVERS_LIST_READER_H__

#include <glib.h>
#include <glib-object.h>

#define	JNA_TYPE_X_SERVERS_LIST_READER			(JnaXServersListReader_getType ())
#define JNA_X_SERVERS_LIST_READER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_X_SERVERS_LIST_READER, JnaXServersListReader))
#define JNA_X_SERVERS_LIST_READER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_X_SERVERS_LIST_READER, JnaXServersListReaderClass))
#define JNA_IS_X_SERVERS_LIST_READER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_X_SERVERS_LIST_READER))
#define JNA_IS_X_SERVERS_LIST_READER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_X_SERVERS_LIST_READER))
#define JNA_X_SERVERS_LIST_READER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_X_SERVERS_LIST_READER_TYPE_NAME(object)	  (g_type_name (JNA_X_SERVERS_LIST_READER_TYPE (object)))

typedef struct _JnaXServersListReader	JnaXServersListReader;
typedef struct _JnaXServersListReaderClass	JnaXServersListReaderClass;

struct _JnaXServersListReader
{
	GObject 		parent_instance;
	GList*			servers;
	GList*			serversList;
};

struct _JnaXServersListReaderClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaXServersListReader_getType		(void);


/* you can free xmlFile after calling this constructor */
GObject* 	
JnaXServersListReader_new			(char* xmlFile);

/* you can free xmlStream after calling this constructor */
GObject* 	
JnaXServersListReader_newFromStream		(char* xmlStream);

/* newly allocated */
char*
JnaXServersListReader_toString		(JnaXServersListReader* self);

void
JnaXServersListReader_print		(JnaXServersListReader* self);


G_END_DECLS

#endif /* __JNA_X_SERVERS_LIST_READER_H__ */
